function love.load()
	img = love.graphics.newImage(love.image.newImageData(1,1))

	---------------------------------
	--                             --
	-- ORIGINAL CODE BY TX95:      --
	-- http://glsl.heroku.com/55/5 --
	--                             --
	---------------------------------
	effect = love.graphics.newPixelEffect [[
extern number time;

// annotations by me

// distance function
number h(vec3 q)
{
	// no fucking idea how to perceive that stuff
	number f = 1.* distance(q, vec3(cos(time)+sin(time*.2), .3, 2.+cos(time*.5)*.5) );
	f *= distance( q, vec3(-cos(time*.7), .3,2. + sin(time*.5)) );
	f *= distance( q, vec3(-sin(time*.2) * .5, sin(time), 2.));
	f *= cos(q.y)*cos(q.x) - .1 - cos(q.z*7. + time*7.) * cos(q.x*3.) * cos(q.y*4.) * .1;
	return f;
}

vec4 effect(vec4 color, Image tex, vec2 tc, vec2 pc)
{
	number threshold = sin(time) * .3 + .5;
	vec2 p = 2.0 * tc - vec2(1.0);                     // pixel coordinate in [-1,1]x[-1,1]
	vec3 o = vec3(p.x, p.y*1.25-0.3, 0.);              // eye pos?
	vec3 d = vec3(p.x + cos(time)*0.3, p.y, 1.) / 64.; // ray direction / speed
	vec4 c = vec4(0.);                                 // color
	number t = 0.;                                     // time the ray intercepts with h
	for (int i = 0; i < 75; i++)
	{
		if (h(o + d*t) < threshold)
		{
			t -= 5.;
			for(int j = 0; j < 5; j++)
			{
				if(h(o + d*t) < threshold)
					break;
				t += 1.;
			}
			vec3 e = vec3(.01,.0,.0);
			vec3 n = vec3(.0);                           // surface normal (approximated)
			n.x = h(o + d*t) - h(vec3(o + d*t + e.xyy)); // move a bit right
			n.y = h(o + d*t) - h(vec3(o + d*t + e.yxy)); // move a bit up
			n.z = h(o + d*t) - h(vec3(o + d*t + e.yyx)); // move a bit back
			n = normalize(n);

			// two light sources?
			c += max( dot(vec3(.0,.0,-.5), n), .0 ) + max( dot(vec3(.0,-.5,.5), n), .0) * .5;
			break;
		}
		t += 5.;
	}

	return c + vec4(.1,.2,.5,1.) * (t * .025);
}
	]]
end

t = 0
function love.update(dt)
	dt = math.min(dt, 1/30)
	t = t + dt
	effect:send('time', t)
end

function love.draw()
	love.graphics.setPixelEffect(effect)
	love.graphics.draw(img, 0,0, 0, love.graphics.getWidth(), love.graphics.getHeight())
end
